VERSION 2.00
Begin Form MainForm 
   BackColor       =   &H00FFFFFF&
   Caption         =   "Edit Grid Demo"
   ClientHeight    =   4335
   ClientLeft      =   360
   ClientTop       =   1695
   ClientWidth     =   6990
   Height          =   5265
   Icon            =   WINFIN.FRX:0000
   Left            =   300
   LinkMode        =   1  'Source
   LinkTopic       =   "Form1"
   ScaleHeight     =   4335
   ScaleWidth      =   6990
   Tag             =   "It's just me, the form"
   Top             =   825
   Width           =   7110
   Begin SSPanel LowerPanel 
      Alignment       =   1  'Left Justify - MIDDLE
      BevelInner      =   2  'Raised
      BevelOuter      =   0  'None
      BorderWidth     =   0
      FloodShowPct    =   0   'False
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "System"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      ForeColor       =   &H00000000&
      Height          =   375
      Left            =   0
      Outline         =   -1  'True
      RoundedCorners  =   0   'False
      TabIndex        =   2
      Top             =   3960
      Width           =   6075
      Begin SSPanel InnerLowerPanel 
         Alignment       =   1  'Left Justify - MIDDLE
         BevelInner      =   1  'Inset
         BevelOuter      =   1  'Inset
         BorderWidth     =   0
         Caption         =   "Editable grid demo -- courtesy of Brian D. Hutchison.  Freeware."
         FontBold        =   0   'False
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   8.25
         FontStrikethru  =   0   'False
         FontUnderline   =   0   'False
         ForeColor       =   &H00000000&
         Height          =   270
         Left            =   150
         TabIndex        =   3
         Top             =   60
         Width           =   5580
      End
   End
   Begin SSPanel TopPanel 
      Font3D          =   1  'Raised w/light shading
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "System"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      ForeColor       =   &H00000000&
      Height          =   420
      Left            =   135
      TabIndex        =   1
      Top             =   150
      Visible         =   0   'False
      Width           =   6660
      Begin SSPanel EditPanel 
         BackColor       =   &H00FFFFFF&
         BevelOuter      =   1  'Inset
         BorderWidth     =   1
         Caption         =   "Panel3D1"
         ForeColor       =   &H00000000&
         Height          =   300
         Left            =   60
         ShadowColor     =   1  'Black
         TabIndex        =   4
         Top             =   60
         Visible         =   0   'False
         Width           =   1665
         Begin TextBox EditCell 
            Alignment       =   1  'Right Justify
            BorderStyle     =   0  'None
            Height          =   240
            Left            =   30
            TabIndex        =   5
            Top             =   60
            Width           =   1545
         End
      End
   End
   Begin Grid Grid1 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "Arial"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      GridLines       =   0   'False
      Height          =   1245
      Left            =   2700
      TabIndex        =   0
      Top             =   1275
      Visible         =   0   'False
      Width           =   2355
   End
   Begin Menu mnuFileMenu 
      Caption         =   "&File"
      Begin Menu mnuBegin 
         Caption         =   "&Begin the demo"
      End
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
'------------------------------------------------------------
'This small VB program demonstrates a method of making the
'VB GRID.VBX editable.  I've spent some time getting ideas
'from various sources--some are even my own.  This program
'is dedicated to all the people that have helped me via
'CompuServe and America Online.
'
'You may cut & paste this code however you want.  I hope
'that you find it useful.  It may not be all that optimized.
'Also, I didn't spend too much time adding comments.
'
'I ask nothing more than that if you find this program useful,
'drop me a line and let me know.  I can be reached at:
'CompuServe: 76470, 3423
'America Online: Seattleite
'-------------------------------------------------------------
Option Explicit     'This is a good idea

Dim SaveData$
Dim SaveEditRow%
Dim SaveEditCol%
Dim EntryInProgress%

Const Fmt$ = "#,##0"
Const KEY_ESCAPE = &H1B
Const KEY_LEFT = &H25
Const KEY_UP = &H26
Const KEY_RIGHT = &H27
Const KEY_DOWN = &H28
Const KEY_F2 = &H71
Const KEY_F9 = &H78

Sub EditCell_Change ()
    'Echoes the contents of the editcell into the grid cell
    'If a user clicks on a new cell the if/then prevents the cell from being blanked
    If Grid1.Col = SaveEditCol% And Grid1.Row = SaveEditRow% And EntryInProgress% Then
	Grid1.Text = EditCell.Text
    End If
End Sub

Sub EditCell_KeyDown (KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
	Case 13, KEY_DOWN    ' Enter key, down arrow
	    'You may want to have an "auto advance" option to
	    'decide if an Enter moves the cursor down.
	    'This demo just does it.
	    KeyCode = 0
	    ProcessEditCellEntry (KEY_DOWN)
	Case KEY_UP
	    'Test to see if the cursor is at the end of the entry.
	    'not so necessary for KEY_UP, but... what the heck.
	    If EditCell.SelStart = Len(EditCell.Text) Then
		KeyCode = 0
		ProcessEditCellEntry (KEY_UP)
	    End If
	Case KEY_RIGHT
	    'Test to see if the cursor is at the end of the entry.
	    If EditCell.SelStart = Len(EditCell.Text) Then
		KeyCode = 0
		ProcessEditCellEntry (KEY_RIGHT)
	    End If
	Case KEY_LEFT
	    'Test to see if the cursor is at the beginning of the entry.
	    If EditCell.SelStart = 0 Then
		KeyCode = 0
		ProcessEditCellEntry (KEY_LEFT)
	    End If
    End Select
End Sub

Sub EditCell_KeyPress (KeyAscii As Integer)
    Select Case KeyAscii
	Case 13    ' Enter key
	    KeyAscii = 0
	Case KEY_ESCAPE
	    Grid1.Text = SaveData$   'Abandon the edit
	    SaveData$ = ""
	    EntryInProgress% = False
	    EditCell.Text = ""       'Necessary to keep the ProcessEditCellEntry from not kicking in
	    EditPanel.Visible = False
	    KeyAscii = 0
	Case 42, 43, 45, 46, 47, 48 To 57, 8 '*, +, -, ., /, 0 thru 9, and BACKSPACE
	    'These are okay
	    'My app only wants to have numbers entered, if you want
	    'the ability to handle more than that, expand the case statement.
	    '...or just take anything with a case else.
	Case Else
	    'The character was something undesirable... make it go away.
	    KeyAscii = 0
    End Select
End Sub

Sub EditCell_LostFocus ()
    Dim TempRow%
    Dim TempCol%
    
    'Put the data back when the user clicks on another cell
    EntryInProgress% = False
    If EditCell.Text <> "" Then ProcessEditCellEntry (0)
End Sub

Function Evaluate# (EditText$, ErrCode)
    Dim Position%
    Dim Operation%
    Dim RightVal#
    Dim LeftVal#
    Dim Balance#
    Dim FirstFlag%
    
    'My thanks to Ethan Winer for this section of code
    'It is mostly adapted from an article by him
    For Position% = 1 To Len(EditText$)
	Operation% = InStr("+-*/", Mid$(EditText$, Position%, 1))
	If Operation% Then
	    LeftVal# = Val(EditText$)
	    If FirstFlag% Then LeftVal# = Balance#
	    If FirstFlag% = False Then
		FirstFlag% = True
		Balance# = 0
	    End If
	    RightVal# = Val(Mid$(EditText$, Position% + 1))
	    
	    Select Case Operation%
		Case 1  'addition
		    If Position% > 1 Then
			Balance# = LeftVal# + RightVal#
		    Else
			Balance# = LeftVal#
		    End If
		Case 2  'subtraction
		    If Position% > 1 Then
			Balance# = LeftVal# - RightVal#
		    Else
			Balance# = LeftVal#
		    End If
		Case 3  'multiplication
		    Balance# = LeftVal# * RightVal#
		Case 4  'division
		    If RightVal# = 0# Then
			ErrCode = 3
			Exit Function
		    End If
		    Balance# = LeftVal# / RightVal#
	    End Select
	End If
    Next Position%
    If FirstFlag% = False Then Balance# = Val(EditText$)
    Evaluate# = Balance#    'Return function result
End Function

Sub Form_Resize ()
    If WindowState <> 1 Then
	If MainForm.Width < 6580 Then MainForm.Width = 6580     'Minimum sizes
	If MainForm.Height < 3405 Then MainForm.Height = 3405
	TopPanel.Top = 0
	TopPanel.Left = 0
	TopPanel.Width = ScaleWidth
	LowerPanel.Top = ScaleHeight - LowerPanel.Height
	LowerPanel.Left = 0
	LowerPanel.Width = ScaleWidth
	InnerLowerPanel.Width = LowerPanel.Width - 630
	Grid1.Top = 0 + TopPanel.Height
	Grid1.Left = 0
	Grid1.Width = ScaleWidth
	Grid1.Height = ScaleHeight - TopPanel.Height - LowerPanel.Height
    End If
End Sub

Sub Grid1_KeyDown (KeyCode As Integer, Shift As Integer)
    Dim CheckRow%
    Dim Pointer%
    Dim ColFlag%
    Dim Counter%
    Dim SaveCol%
    On Error GoTo Grid1KeyDownError:

    Select Case KeyCode
	Case 13, 27
	    KeyCode = 0
	Case KEY_F2
	    SaveEditRow% = Grid1.Row
	    SaveEditCol% = Grid1.Col
	    SaveData$ = Grid1.Text      ' Save in case press Esc later
	    StartEditCell 0, 1
	Case KEY_F9
	    MousePointer = 11
	    InnerLowerPanel.Caption = " Please wait..."
	    SaveEditRow% = Grid1.Row
	    'DoGridCalc     (In my full app, this calcs the formulaes and such)
	    MousePointer = 0
	    InnerLowerPanel.Caption = " Ready"
    End Select
    Exit Sub
Grid1KeyDownError:
    MsgBox Str$(Err) + " error in Grid1/KeyDown subprogram.", 16, "Error"
    Resume Next
End Sub

Sub Grid1_KeyPress (KeyAscii As Integer)
    Dim CheckRow%
    Dim Pointer%
    On Error GoTo Grid1KeyPressError:

    Select Case KeyAscii
	Case 13         'Enter
	    KeyAscii = 0
	    ProcessExtendedKeys KEY_DOWN         ' move
	Case 27         'Esc
	    ' Do nothing
	    KeyAscii = 0
	Case 43, 45, 46, 48 To 57  '+, -, ., And 0 Thru 9
	    If Grid1.Col < Grid1.FixedCols Then
		KeyAscii = 0
		Exit Sub
	    End If
	    SaveEditRow% = Grid1.Row
	    SaveEditCol% = Grid1.Col
	    SaveData$ = Grid1.Text      ' Save in case press Esc later
	    StartEditCell KeyAscii, 0
	Case Else
	    ' Do nothing
	    KeyAscii = 0
    End Select
    Exit Sub
Grid1KeyPressError:
    MsgBox Str$(Err) + " error in Grid1/KeyPress subprogram.", 16, "Error"
    Resume Next
End Sub

Sub mnuBegin_Click ()
    Dim X%

    'Just some code to make the grid interesting
    Grid1.Cols = 8
    Grid1.Rows = 25
    Grid1.Col = 0
    For X% = 1 To Grid1.Rows - 1
	Grid1.Row = X%
	Grid1.Text = Str$(X%)
    Next X%
    Grid1.Row = 0
    For X% = 1 To Grid1.Cols - 1
	Grid1.ColWidth(X%) = 850
	Grid1.FixedAlignment(X%) = 1      'Left aligned
	Grid1.ColAlignment(X%) = 1      'Left aligned
	Grid1.Col = X%
	Grid1.Text = Str$(X%)
    Next X%
    Grid1.Visible = True
    TopPanel.Visible = True
End Sub

Sub mnuFileExit_Click ()
    Unload MainForm
End Sub

Sub ProcessEditCellEntry (KeyMove As Long)
    Dim X%
    Dim SaveNewRow%         'Used if user clicks mouse to
    Dim SaveNewCol%         'different cell
    Dim ErrCode
    Dim Answer#
    Dim GridText$

    On Error GoTo EditCellKeyPressError:

    EditPanel.Visible = False
    MousePointer = 11
    GridText$ = EditCell.Text
    EditCell.Text = ""
    Answer# = Evaluate#(GridText$, ErrCode)
    If Answer# > 100000000000# Then     'No reason on this green earth for a number this
	Err = 6                         'large in my app.  Better to stop this now
	GoTo EditCellKeyPressError:
    End If
    
    X% = DoEvents()
    
    'I place the Answer# into the appropriate arrays here in my own app.

    'The following handles the case of the user clicking the cursor
    'to a different cell while in the edit mode
    If Grid1.Col = SaveEditCol% And Grid1.Row = SaveEditRow% Then
	Grid1.Text = Format$(Answer#, Fmt$)
    Else
	'Keep track of where the new cell is
	SaveNewCol% = Grid1.Col
	SaveNewRow% = Grid1.Row
	'Need to switch back to the original cell
	Grid1.Col = SaveEditCol%
	Grid1.Row = SaveEditRow%
	Grid1.Text = Format$(Answer#, Fmt$)
	'Put them back in their new cell
	Grid1.Col = SaveNewCol%
	Grid1.Row = SaveNewRow%
    End If
    'DoGridCalc    ' Calculate the total rows-removed for demo
    ProcessExtendedKeys KeyMove   ' Next cell
    MousePointer = 0
Exit Sub

EditCellKeyPressError:
    If Err = 6 Then
	MsgBox "Number is way too large!" + Chr$(10) + "Enter a number under one trillion or so!", 48, "Invalid Number"
    Else
	MsgBox "Unexpected error #" + Str$(Err) + " in processing that number.  Try again.", 48, "Invalid Number"
    End If
    MousePointer = 0
    Resume Next
End Sub

Sub ProcessExtendedKeys (KeyMove As Long)
    Select Case KeyMove
	Case KEY_DOWN
	    SendKeys "{DOWN}"
	Case KEY_UP
	    SendKeys "{UP}"
	Case KEY_RIGHT
	    SendKeys "{RIGHT}"
	Case KEY_LEFT
	    SendKeys "{LEFT}"
    End Select
End Sub

Sub StartEditCell (KeyAscii As Integer, KeyCode As Integer)
    Dim CheckRow%
    Dim Pointer%
    Dim StartNum%
    Dim AssumNum%
    
    On Error GoTo StartEditCellError:

    EntryInProgress% = True

    If KeyCode = 1 Then    'They pressed F2 to edit the cell
	EditCell.Text = Grid1.Text
	SendKeys "{END}"   'place cursor at end of number
    Else                   'They just started typing to start entering something new
	EditCell.Text = ""
    End If
    EditPanel.Visible = True
    EditCell.SetFocus
    If KeyAscii Then    'If they typed something to the grid, pass it to the Textbox
	SendKeys Chr$(KeyAscii)
    End If
Exit Sub

StartEditCellError:
    MsgBox Str$(Err) + " error in StartEditCell subprogram.", 16, "Error"
    Resume Next
End Sub

