Option Explicit

Type RECT
    left As Integer
    Top As Integer
    right As Integer
    Bottom As Integer
End Type

Declare Sub GetWindowRect Lib "User" (ByVal hwnd%, lpRect As RECT)
Declare Function GetKeyState% Lib "User" (ByVal nVirtKey%)
Declare Sub GetKeyBoardState Lib "User" (ByVal lpKeyState$)
Declare Sub SetKeyboardState Lib "User" (ByVal lpKeyState$)
Declare Sub SetCursorPos Lib "User" (ByVal x%, ByVal y%)
Declare Function GetTextExtent& Lib "GDI" (ByVal hdc%, ByVal lpstring$, ByVal length%)

Function Getinput$ (Text As String, Validation As String, InValue As String)
    Dim MStore As Integer
    
    MStore = Screen.MousePointer
    Screen.MousePointer = 0

    MsgWin.message.Caption = Text
    MsgWin.Text1.Tag = Validation
    MsgWin.Text1.Text = InValue
    MsgWin.Text1.Visible = True
    MsgWin.Text1.SelLength = Len(InValue)

    MsgWin.Show 1
    Getinput = MsgWin.Text1.Text
    Unload MsgWin


End Function

Sub message (Text As String)
    MsgWin.message.Caption = Text
    MsgWin.Show 1
    Unload MsgWin
End Sub

Function Prompt (Text As String, MsgType As Integer) As Integer
    Dim MStore As Integer
    

    Load MsgWin
    MStore = Screen.MousePointer
    Screen.MousePointer = 0

    MsgWin.message.Caption = Text
    If MsgType = 1 Then
	MsgWin.Button1.Caption = "&Yes"
	MsgWin.Button2.Caption = "&No"
	MsgWin.Button1.Visible = True
    End If

    If MsgType = 2 Then
	MsgWin.Button1.Caption = "&Order"
	MsgWin.Button2.Caption = "&Allocate"
	MsgWin.Button1.Visible = True
    End If

    If MsgType = 3 Then
	MsgWin.Button1.Caption = "&OK"
	MsgWin.Button2.Caption = ""
	MsgWin.Button1.Visible = True
    End If

    If MsgType = 4 Then
	MsgWin.Button1.Caption = "&No"
	MsgWin.Button2.Caption = "&Yes"
	MsgWin.Button1.Visible = True
    End If
    
    MsgWin.Show 1
    Prompt = Val(MsgWin.Answer.Text)
    Unload MsgWin
    Set MsgWin = Nothing

    Screen.MousePointer = MStore

End Function

